#*************************************************************
# Progamm:			graphik_vergleich
# Sinn des Programms: 		Graphische Darstellung und Vergleich von zwei Funktionen
# Sinn der Einheit  :		Ausgabeeinheit	
# Name dieser Datei:		rechner.py
# Versionsnummer:		2
# Wird aufgerufen von:		graphik_vergleich_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			19.02.2024
# Letzte Änderung: 		04.03.2024
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt


class Ausgabe:

  def __init__(self):		
    print("Ausgabeobjekt erzeugt")

  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")   


#*************************************************************
# Funktion zur Ausgabe in der Konsole
#*************************************************************    
  def schirm_ausgabe(self,m,x,y):
    print("Schirmaugabe")
    for i in range(m + 1):
      print ("%5i" %i,"%6.5f" %x[i], "%6.5f" %y[i])
      

#*************************************************************
# Funktion zur Ausgabe in eine Datei
#*************************************************************
  def datei_ausgabe(self, ausgabe_datei, m, x, y):
    fobj_out = open(ausgabe_datei,"w")
    for i in range(m + 1):
      fobj_out.write(str("%5i" %i))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %x[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %y[i])) 
      fobj_out.write("\n")
    fobj_out.close()   
    
#*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
  def graphik_ausgabe(self,m, x, y, graphik_datei_wähler,graphik_datei, graphik_format, graphik_titel, graphik_ordinate):
    x_min=2000.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    i_max = m - 1
    for i in range(i_max+1):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]
      if y_min >= y[i]:
        y_min = y[i]
      if y_max <= y[i]:
        y_max = y[i]
    plt.plot(x, y,'r') #, 'r.'
      # Achsen-Bereiche manuell festlegen
#    plt.errorbar(x, y,  yerr=Delta_y, fmt = '-r', ms=10, ecolor='g', elinewidth = 1, capsize = 10, capthick = 1)    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title(graphik_titel)
    plt.xlabel('Zeit [Jahr]')
    plt.ylabel(graphik_ordinate)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      plt.savefig(graphik_datei + "." + graphik_format, format=graphik_format)
     # Diagramm anzeigen:
    plt.show()  
    
