#*************************************************************
# Progamm:			graphik_vergleich
# Sinn des Programms: 		Graphische Darstellung und Vergleich von zwei Funktionen
# Sinn der Einheit  :		Einlesen der Steurdaten aus der Steuerdatei	
# Name dieser Datei:		datei_einlese.py
# Versionsnummer:		2
# Wird aufgerufen von:		graphik_vergleich_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			10.02.2024
# Letzte Änderung: 		04.03.2024
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateifunktionen
#*************************************************************
import os
import numpy as np

class Datei_einlese:

  def __init__(self):		
    print("Datei_leseobjekt erzeugt")
    rückgabe_tupel_temperatur = True,
    rückgabe_tupel_meeresspiegel = True,
  #Destruktormethode
  def __del__(self):	
    print("Datei_leseobjekt entfernt")   

#*************************************************************
# Funktion zum Öffnen der ISA-datei und zum Auslesen der
# Atmosphärendaten
#*************************************************************
  def temperatur_datei_input(self, temperatur_datei):
    print("Einlesen der Eingabedaten aus: ", temperatur_datei) 
    daten_zähler = 0
    if os.path.exists(temperatur_datei):
      print("Temperaturdatei", temperatur_datei, "ist vorhanden")
      with open(temperatur_datei, "r") as fobj_in:
        while True: 
          zeile = fobj_in.readline()
          zeile = zeile[:-1]
          daten_liste_test = zeile.split(",")
          try:
            jahr_test = int(daten_liste_test[0])
            daten_zähler += 1              
          except:
            print(zeile, "Keine Zahl") 
          if len(zeile) == 0: # eine leere Zeile bedeutet Dateiende (EOF)
            break    
      print("Daten in Temperaturdatei", temperatur_datei,":",  daten_zähler)  
      
      self.jahr_temperatur = np.zeros(daten_zähler) 
      self.temperatur = np.zeros(daten_zähler)  
      i = 0     
      with open(temperatur_datei, "r") as fobj_in:
        while True: 
          zeile = fobj_in.readline()
          zeile = zeile[:-1]
          daten_liste = zeile.split(",")
          try:
            jahr = int(daten_liste[0])
            #if len(daten_liste) == 3:
            if 1880 <= jahr and jahr <= 2013:
              # print(daten_liste[0], daten_liste[1], daten_liste[2])              
              self.jahr_temperatur[i] = float(daten_liste[0])
              self.temperatur[i] = float(daten_liste[1])
              # print("i=", i, "jahr=", jahr) 
              self.i_max_temperatur = i             
              i+=1
          except:
            print(zeile, "Keine Zahl") 
          if len(zeile) == 0: # eine leere Zeile bedeutet Dateiende (EOF)
            break      
                
      return True
    else:
      print("Temperaturdatei", temperatur_datei, "ist NICHT vorhanden")  
      return False

  def meeresspiegel_datei_input(self, meeresspiegel_datei):
    print("Einlesen der Eingabedaten aus: ", meeresspiegel_datei) 
    daten_zähler = 0
    if os.path.exists(meeresspiegel_datei):
      print("Meeresspiegeldatei ", meeresspiegel_datei,"ist vorhanden")
      with open(meeresspiegel_datei, "r") as fobj_in:
        while True: 
          zeile = fobj_in.readline()
          zeile = zeile[:-1]
          daten_liste_test = zeile.split(",")
          try:
            jahr = int(daten_liste_test[0])
            daten_zähler += 1
          except:
            print(zeile, "Keine Zahl")  
          if len(zeile) == 0: # eine leere Zeile bedeutet Dateiende (EOF)
            break    
      print("Daten in Meeresspiegeldatei" , meeresspiegel_datei,":",  daten_zähler)    
      
      self.jahr_meeresspiegel = np.zeros(daten_zähler) 
      self.meeresspiegel = np.zeros(daten_zähler)        
      i = 0 
      inch_to_mm = 25.4 
      with open(meeresspiegel_datei, "r") as fobj_in:
        while True: 
          zeile = fobj_in.readline()
          zeile = zeile[:-1]
          daten_liste = zeile.split(",")
          try:
            jahr = int(daten_liste[0])
            #if len(daten_liste) >= 3: 
            if 1880 <= jahr and jahr <= 2013:           
              self.jahr_meeresspiegel[i] = float(daten_liste[0])
              self.meeresspiegel[i] = float(daten_liste[1]) * inch_to_mm   
              self.i_max_meeresspiegel = i                   
              i+=1

          except:
            print(zeile, "Keine Zahl") 
          if len(zeile) == 0: # eine leere Zeile bedeutet Dateiende (EOF)
            break 
  
      if self.i_max_temperatur == self.i_max_meeresspiegel:
        self.i_max = self.i_max_temperatur
        print("i_max = ", self.i_max)

      self.jahr_temperatur.resize(self.i_max+1)
      self.temperatur.resize(self.i_max+1)
      self.jahr_meeresspiegel.resize(self.i_max+1)  
      self.meeresspiegel.resize(self.i_max+1) 
 
      print(self.jahr_temperatur) 
      print(self.temperatur)        
      print(self.jahr_meeresspiegel) 
      print(self.meeresspiegel)                              
      return True      
         
    else:
      print("Meeresspiegeldatei ", meeresspiegel_datei,"ist NICHT vorhanden")      
      return False
