#*************************************************************
# Progamm:			graphik_vergleich
# Sinn des Programms: 		Graphische Darstellung und Vergleich von zwei Funktionen
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		graphik_vergleich_haupt.py
# Versionsnummer:		2
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, datei_einlese.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			10.02.2024
# Letzte Änderung: 		04.03.2024
#*************************************************************

#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime
import sys


#*************************************************************
# Importieren der Klassen
#*************************************************************
from steuer import Steuer
from datei_einlese import Datei_einlese
from ausgabe import Ausgabe

#*************************************************************
# Belegung der Klassen
#*************************************************************
steuer = Steuer()
datei_einlese = Datei_einlese()
ausgabe = Ausgabe()

#*************************************************************
# Ausgabe an
#*************************************************************

print("Modulname =", __name__)

if __name__ == "__main__":

#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
  dt_start = datetime.datetime.now()
  lt_start = time.localtime()
  jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
  datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)


  print("Zeitreihenanalyse durch scharfes Hinsehen")


#*************************************************************
# öffnen der Log-Datei
#*************************************************************
  with open("graphik_vergleich.log", "w") as fobj_log:
#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
    fobj_log.write("Anfang: "+ "\n" + datum_zeit)
    fobj_log.write("\n")
#*************************************************************
# Prüfung, ob Steuerdatei erfolgreich geöffnet wurde
#*************************************************************
    if(steuer.steuer_input()):
      fobj_log.write( "Einlesen der Steuerdatei funktionierte\n")


#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
    lt_end = time.localtime()
    jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
    datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
    dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
    dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
    fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
    fobj_log.write("Rechendauer: "+ "\n" + str(dauer)+ "\n" )

#*************************************************************
# Einlesen der Temperatur- und Meeresspiegeldaten 
#************************************************************* 

    if(datei_einlese.temperatur_datei_input(steuer.temperatur_datei)):
      fobj_log.write( "Datei existiert\n")
    
    if(datei_einlese.meeresspiegel_datei_input(steuer.meeresspiegel_datei)):
      fobj_log.write( "Datei existiert\n")  
#*************************************************************
# Ausgabe der Lösung auf Schirm, in Datei, als Graphik 
#*************************************************************      
    if steuer.schirm_ausgabe_wähler : 
      ausgabe.schirm_ausgabe(datei_einlese.i_max,datei_einlese.jahr_temperatur, datei_einlese.temperatur)
      ausgabe.schirm_ausgabe(datei_einlese.i_max,datei_einlese.jahr_meeresspiegel, datei_einlese.meeresspiegel) 
    if steuer.datei_ausgabe_wähler: 
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_1,datei_einlese.i_max,datei_einlese.jahr_temperatur,datei_einlese.temperatur)
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_2,datei_einlese.i_max,datei_einlese.jahr_meeresspiegel,datei_einlese.meeresspiegel)   
    if steuer.graphik_ausgabe_wähler: 
      ausgabe.graphik_ausgabe(datei_einlese.i_max,datei_einlese.jahr_temperatur,datei_einlese.temperatur, steuer.graphik_datei_ausgabe_wähler,\
      steuer.graphik_datei_1,steuer.graphik_format_1,steuer.graphik_titel_1, steuer.graphik_ordinate_1)
      ausgabe.graphik_ausgabe(datei_einlese.i_max,datei_einlese.jahr_meeresspiegel,datei_einlese.meeresspiegel, steuer.graphik_datei_ausgabe_wähler,\
      steuer.graphik_datei_2,steuer.graphik_format_2,steuer.graphik_titel_2, steuer.graphik_ordinate_2)                

#*************************************************************
# Schließen der Logdatei und Programmende
#*************************************************************



